;**************************************************************************
; PROGRAM.ASM
;
;
;--------------------------------------------------------------------------
;
;**************************************************************************

	RADIX	DEC
	CONFIG	0x3F69

IROBIT	EQU	3		; slo bitu pro vstup na infra
INDBIT	EQU	4		; slo bitu k indikaci on-line

SPBRG	EQU	99h
TXSTA	EQU	98h
RCSTA	EQU	18h
RCREG	EQU	1Ah
TXREG	EQU	19h
PIR1	EQU	0ch
PIE1	EQU	8ch

TMR1L	EQU	0Eh
TMR1H	EQU	0Fh
T1CON	EQU	10h

;--------------------------------------------------------------------------
;	data
;--------------------------------------------------------------------------

	CBLOCK	0x20

; ----- vysln IR kdu (data se vyslaj on nich bit)

Citac1				; ta 1 vnitn prodlevy signlu
Citac2				; ta 2 vnitn prodlevy signlu
Citac3				; ta k odesln prodlevy mezi kdy
PushWB				; schova W pro vstup bitu

ParTPM				; parametry pro tyfzovou modulaci
				; bit0: je druh bit (ignoruje se)
				; bit7: je tyfzov modulace

DataI				; index dat k vysln infra
DataB				; ta bit k vysln infra
DataB0				; ta bit k vysln infra pro 1 bajt

RecW				; schova W pi monitorovn IR

; ----- pjem paketu

RecC				; ta dat pi pjmu paketu

; ----- definice kdu (paket pijat od PC, 29 bajt = penos 15 ms)

HeadPak				; 0: zhlav paketu (mus bt 0x21)

Repeat				; 1: poet opakovn kdu (1 a 255)

Carrier				; 2: frekvence
				;  0: 28 kHz (27.78 kHz)
				;  1: 30 kHz (29.41 kHz) (Libue, Base=1)
				;  2: 32 kHz (31.25 kHz)
				;  3: 34 kHz (33.33 kHz)
				;  4: 36 kHz (35.71 kHz) ... implicitn
				;  5: 38 kHz (38.46 kHz)
				;  6: 41 kHz (41.67 kHz)
				;  7: 45 kHz (45.45 kHz)
				;  8: 50 kHz (50.00 kHz)

Modul				; 3: modulace
				;  0: NUL (jin modulace)
				;	bit 0,1 (nebo bit 4,5): ka impulsu "1" 1 a 4
				;	bit 2,3 (nebo bit 6,7): ka impulsu "0" 1 a 4
				;  1: PWM (Pulse-Width-Modulation) ... Sony
				;       (modulace ky impulsu)
				;	"0": T signl, T mezera
				;	"1": 2T signl, T mezera
				;  2: SWM (Space-Width-Modulation) ... Panasonic, Libue
				;       (modulace ky mezery)
				;	"0": T signl, T mezera
				;	"1": T signl, 3T mezera
				;  3: RWM (Relative-Width-Modulation) ... hraky
				;	(modulace pomrn ky)
				;	"0": T signl, 3T mezera
				;	"1": 3T signl, T mezera
				;  4: ESM (Edge-Shift-Modulation) ... Philips, Finlux
				;	(modulace zmny hrany)
				;	"0": T signl, T mezera
				;	"1": T mezera, T signl
				;  5: BWM (Bit-Width-Modulation)
				;	(modulace ky bitu)
				;	"0": T signl, T mezera
				;	"1": 2T signl, 2T mezera
				;  6: TPM (Tetra-Phase-Modulation)
				;	(tyfzov modulace)
				;        "0": T mezera, T signl, 3T mezera, T signl
				;        "1": 2T mezera, T signl, 2T mezera, T signl
				;        "2": 3T mezera, T signl, T mezera, T signl
				;        "3": 4T mezera, 2T signl

Base				; 4: bze - poet puls pro T (1 definin bajt)
Head1				; 5: poet T pro "1" zhlav (1 definin bajt, 0=nen)
Head2				; 6: poet T pro "0" zhlav (1 definin bajt, 0=nen)
Tail1				; 7: poet T pro "1" zpat (1 definin bajt, 0=nen)
Tail2				; 8: poet T pro "0" zpat (1 definin bajt, 0=nen)
Tail3				; 9: poet T pro "1" zpat (1 definin bajt, 0=nen)
IntDel				; 10: prodleva mezi kdy v [ms] (1 definin bajt)
Bites				; 11: poet datovch bit v kdu (1 definin bajt, max. 64)

Codes0				; 12: data kdu - bajt 0 (pen se od nejnich bit LSB)
Codes1				; 13: data kdu - bajt 1 (pen se od nejnich bit LSB)
Codes2				; 14: data kdu - bajt 2 (pen se od nejnich bit LSB)
Codes3				; 15: data kdu - bajt 3 (pen se od nejnich bit LSB)
Codes4				; 16: data kdu - bajt 4 (pen se od nejnich bit LSB)
Codes5				; 17: data kdu - bajt 5 (pen se od nejnich bit LSB)
Codes6				; 18: data kdu - bajt 6 (pen se od nejnich bit LSB)
Codes7				; 19: data kdu - bajt 7 (pen se od nejnich bit LSB)
Codes8				; 20: data kdu - bajt 8 (pen se od nejnich bit LSB)
Codes9				; 21: data kdu - bajt 9 (pen se od nejnich bit LSB)
CodesA				; 22: data kdu - bajt 10 (pen se od nejnich bit LSB)
CodesB				; 23: data kdu - bajt 11 (pen se od nejnich bit LSB)
CodesC				; 24: data kdu - bajt 12 (pen se od nejnich bit LSB)
CodesD				; 25: data kdu - bajt 13 (pen se od nejnich bit LSB)
CodesE				; 26: data kdu - bajt 14 (pen se od nejnich bit LSB)
CodesF				; 27: data kdu - bajt 15 (pen se od nejnich bit LSB)

CRC				; 28: kontroln souet paketu (vetn zhlav 0x21)

	ENDC

;--------------------------------------------------------------------------
;	start programu
;--------------------------------------------------------------------------

; ----- start po resetu

	org	0
	goto	Start		; start programu

;--------------------------------------------------------------------------
;	Prodleva pro jednu periodu signlu
;--------------------------------------------------------------------------

; Obvykl frekvence [kHz]: 29, 32, 35.5, 36, 37.5, 39.2, 40, 44

; Vpoty frekvenc (takt procesoru 4MHz je 1 us):
; 26.32 kHz: 38 us, "1"=19T, "0"=19T
; 27.03 kHz: 37 us, "1"=18T, "0"=19T
; 27.78 kHz: 36 us, "1"=18T, "0"=18T !!!
; 28.57 kHz: 35 us, "1"=17T, "0"=18T
; 29.41 kHz: 34 us, "1"=17T, "0"=17T !!!
; 30.30 kHz: 33 us, "1"=16T, "0"=17T
; 31.25 kHz: 32 us, "1"=16T, "0"=16T !!!
; 32.26 kHz: 31 us, "1"=15T, "0"=16T
; 33.33 kHz: 30 us, "1"=15T, "0"=15T !!!
; 34.48 kHz: 29 us, "1"=14T, "0"=15T
; 35.71 kHz: 28 us, "1"=14T, "0"=14T !!!
; 37.04 kHz: 27 us, "1"=13T, "0"=14T
; 38.46 kHz: 26 us, "1"=13T, "0"=13T !!!
; 40.00 kHz: 25 us, "1"=12T, "0"=13T
; 41.67 kHz: 24 us, "1"=12T, "0"=12T !!!
; 43.48 kHz: 23 us, "1"=11T, "0"=12T
; 45.45 kHz: 22 us, "1"=11T, "0"=11T !!!
; 47.62 kHz: 21 us, "1"=10T, "0"=11T
; 50.00 kHz: 20 us, "1"=10T, "0"=10T !!!

; 0: 28 kHz (18) ... 27.78 kHz
; 1: 30 kHz (17) ... 29.41 kHz
; 2: 32 kHz (16) ... 31.25 kHz
; 3: 34 kHz (15) ... 33.33 kHz
; 4: 36 kHz (14) ... 35.71 kHz
; 5: 38 kHz (13) ... 38.46 kHz
; 6: 41 kHz (12) ... 41.67 kHz
; 7: 45 kHz (11) ... 45.45 kHz
; 8: 50 kHz (10) ... 50.00 kHz

; Z volan funkce se pro "1" pidv prodleva:
;	movf ......... 1 takt
;	call ......... 2 takty
;	nop .......... 1 takt
;	movf ......... 1 takt
;	bcf .......... 1 takt

;          celkem = 6 takt

; Z volan funkce se pro "0" pidv prodleva:
;	call ......... 2 takty
;       decfsz ....... 1 takt
;       goto ......... 2 takty
;	bsf .......... 1 takt

;          celkem = 6 takt

Delay	addwf	PCL,F		; 2 takty

Delay18	nop			; 1 takt
Delay17	nop			; 1 takt
Delay16	nop			; 1 takt
Delay15	nop			; 1 takt
Delay14	nop			; 1 takt
Delay13	nop			; 1 takt
Delay12	nop			; 1 takt
Delay11	nop			; 1 takt
Delay10	return			; 2 takty
				;   +6 takt z hlavn funkce

;--------------------------------------------------------------------------
;	Obsluha vstupu jednoho bitu pro rzn modulace
;--------------------------------------------------------------------------

ModTab	movf	Modul,W		; kd modulace
	addwf	PCL,F

	goto	OutNUL		; 0: jin modulace
	goto	OutPWM		; 1: modulace ky pulsu
	goto	OutSWM		; 2: modulace ky mezery
	goto	OutRWM		; 3: modulace pomrn ky
	goto	OutESM		; 4: modulace zmny hrany
	goto	OutBWM		; 5: modulace ky bitu
	goto	OutTPM		; 6: tyfzov modulace

;--------------------------------------------------------------------------
;	start programu - inicializace
;--------------------------------------------------------------------------

; ----- inicializace portu B

Start	bcf	STATUS,RP1	; banky 0 a 1
	bsf	STATUS,RP0	; banka 1
	bcf	STATUS,IRP	; banky 0 a 1

	movlw	B'11100011'	; bit2: vstup TXD, bit3: vstup IR
	movwf	TRISB

; ----- nastaven baud genertoru (19200 Baud, 8 bit, bez parity, 1 STOP)

	movlw	12
	movwf	SPBRG

; ----- nastaven vyslae (HIGH speed, ASYN, povoleno vysln, 8bit)

	movlw	bit2+bit5
	movwf	TXSTA

; ----- vypnut vstup na port B

	bcf	STATUS,RP0	; banka 0
	movlw	B'11110111'
	movwf	PORTB

; ----- nastaven pijmae (povolen pjem, 8bit, sriov port aktivn)

	movlw	bit4+bit7
	movwf	RCSTA

;rrr2 	call	RXByte
;	call	TXByte
;	goto	rrr2

;--------------------------------------------------------------------------
;	pjem povelu od PC (implicitn je trvale banka 0 !!!)
;--------------------------------------------------------------------------

; ----- pjem povelu

Receiv	call	RXByte		; pjem bajtu z USART
	movwf	HeadPak		; schova bajtu - zhlav paketu

; ----- identifikace IR interface 0x23

	movlw	0x23		; povel pro identifikaci interface
	subwf	HeadPak,W	; test, zda je poadavek identifikace
	btfss	STATUS,Z	; je to poadavek k identifikaci?
	goto	Rec2		; nen to poadavek k identifikaci

	bcf	PORTB,INDBIT	; vypnut LED pro indikaci
	movlw	0x32		; identifikace - verze interface "2"
	call	TXByte		; odesln bajtu na USART
	goto	Receiv		; pjem dalho povelu

; ----- povel k vysln IR povelu 0x21

Rec2	movlw	0x21		; povel pro vysln IR kdu
	subwf	HeadPak,W	; test, zda je to zhlav paketu
	btfss	STATUS,Z	; je to zhlav paketu?
	goto	Rec4		; nen to zhlav paketu	

; ----- inicializace pro pjem IR kdu

	movlw	Repeat		; zatek dat k pjmu
	movwf	FSR		; index dat k pjmu

	movlw	CRC - Repeat	; poet bajt k pjmu
	movwf	RecC		; poet bajt k pjmu

	movlw	0x21		; zhlav paketu
	movwf	CRC		; inicializace stadae CRC

; ----- pjem dat paketu

Rec3	call	RXByte		; pjem bajtu paketu
	movwf	INDF		; uloen pijatho bajtu
	addwf	CRC,F		; piten bajtu ke stadai CRC
	incf	FSR,F		; zven ukazatele dat
	decfsz	RecC,F		; ta dat k pjmu
	goto	Rec3		; pjem dalho bajtu dat

; ----- pjem CRC

	call	RXByte		; pjem CRC
	subwf	CRC,W		; kontrola CRC
	btfss	STATUS,Z	; je chyba CRC?
	goto	Rec32		; je chyba CRC

; ----- kontrola hodnot poloek

	movf	Repeat,W	; kontrola potu opakovn
	btfsc	STATUS,Z	; poet opakovn nesm bt = 0
	goto	Rec34		; chyba, poet opakovn = 0

	movlw	9		; max. hodnota pro Carrier + 1
	subwf	Carrier,W	; kontrola hodnoty nosn
	btfsc	STATUS,C	; je peteen hodnoty nosn?
	goto	Rec34		; je peteen hodnoty nosn	
	
	movlw	7		; max. hodnota pro Modul + 1
	subwf	Modul,W		; kontrola hodnoty modulace
	btfsc	STATUS,C	; je peteen hodnoty modulace?
	goto	Rec34		; je peteen hodnoty modulace	

	movf	Base,W		; kontrola potu puls na bzi
	btfsc	STATUS,Z	; poet puls na T nesm bt = 0
	goto	Rec34		; chyba, poet puls na T = 0

	movf	Bites,W		; kontrola potu bit
	btfsc	STATUS,Z	; poet bit nesm bt = 0
	goto	Rec34		; chyba, poet bit = 0

	movlw	65		; max. hodnota pro Bites
	subwf	Bites,W		; kontrola hodnoty Bites
	btfsc	STATUS,C	; je peteen hodnoty potu bit?
	goto	Rec34		; je peteen hodnoty potu bit

	goto	Send		; pjem je OK

; ----- chyba CRC paketu 0x58

Rec32	movlw	0x58		; znak hlen chyby
	call	TXByte		; odesln hlen chyby CRC
	goto	Receiv

; ----- chyba dat paketu 0x5A

Rec34	movlw	0x5A		; znak hlen chyby
	call	TXByte		; odesln hlen chyby dat
	goto	Receiv

; ----- povel k monitorovn IR

Rec4	movlw	0x2f		; povel k monitorovn IR
	subwf	HeadPak,W	; test, zda to je povel k monitorovn
	btfsc	STATUS,Z	; je to monitorovn IR?
	goto	Monit		; obsluha monitorovn

; ----- indikace on-line (bliknut asi 0.04 sekundy)

	movlw	0x24		; povel pro indikaci on-line
	subwf	HeadPak,W	; test, zda je poadavek indikace
	btfss	STATUS,Z	; je to poadavek k indikaci?
	goto	Rec6		; nen to poadavek k indikaci

	bsf	PORTB,INDBIT	; zapnut LED pro indikaci

	movlw	0x30
	movwf	Citac1
	clrf	Citac2
Rec5	decfsz	Citac2,F	; (1) dekrementace tae
	goto	Rec5		; (2) dal T signlu
	decfsz	Citac1,F
	goto	Rec5

	bcf	PORTB,INDBIT	; vypnut LED pro indikaci
	goto	Receiv		; dal pjem

; ----- neplatn povel (synchronizace)

Rec6	goto	Receiv

;--------------------------------------------------------------------------
;	monitorovn IR vstupu
;--------------------------------------------------------------------------
; Penosov rychlost 115200 Baud:
; 1 penosov bit za 8.68 us, 10 bit za 88 us
;	START: 9 us
;	bit 0: 8 us
;	bit 1: 9 us
;	bit 2: 9 us
;	bit 3: 8 us
;	bit 4: 9 us
;	bit 5: 9 us
;	bit 6: 8 us
;	bit 7: 9 us
;	STOP: 10 us
; 1 datov bit za 11 us, celkem 88 us

; Zkusmo zjitno: minimln doba na 1 bit USART 8.33 us, max. 9.25 us, sted 8.79
;--------------------------------------------------------------------------

; ----- inicializace

Monit	bcf	RCSTA,7		; zkaz USART portu
	bsf	PORTB,2		; nastaven STOP bitu
	clrf	RecW		; nulovn stadae bit

; ----- prodleva ped zahjenm vysln pro inicializaci USART na PC (0.2 sec)

	clrf	Citac1
	clrf	Citac2
Monit3	decfsz	Citac2,F	; (1) dekrementace tae
	goto	Monit3		; (2) dal T signlu
	decfsz	Citac1,F
	goto	Monit3

; ----- naten portu B

Monit1	movf	PORTB,W		; 1us naten portu B do W

; ----- START (9 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu
	
	btfss	PORTB,0		; 1us
	bsf	RecW,1		; 1us
	btfss	PORTB,0		; 1us
	bsf	RecW,1		; 1us
	nop			; 1us

; ----- bit 0 (8 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	btfsc	RecW,0		; 1us m bt bit 0?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	btfss	PORTB,0		; 1us
	bsf	RecW,2		; 1us
	btfss	PORTB,0		; 1us
	bsf	RecW,2		; 1us

; ----- bit 1 (9 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	btfsc	RecW,1		; 1us m bt bit 1?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	nop			; 1us
	btfss	PORTB,0		; 1us
	bsf	RecW,3		; 1us

; ----- bit 2 (9 us)

	andlw	~b'100'		; 1us vynulovn bitu 2

	btfss	PORTB,0		; 1us
	bsf	RecW,3		; 1us

	btfsc	RecW,2		; 1us m bt bit 2?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	btfss	PORTB,1		; 1us test, zda jsou njak data od PC
	goto	Monit2		; 1us jsou data - peruen
	nop			; 1us

; ----- bit 3 (8 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	btfsc	RecW,3		; 1us m bt bit 3?
	iorlw	b'100'		; 1us nastaven bitu 2

	btfss	PORTB,0		; 1us
	bsf	RecW,4		; 1us

	movwf	PORTB		; 1us odesln hodnoty bitu

	btfss	PORTB,0		; 1us
	bsf	RecW,4		; 1us
	btfss	PORTB,1		; 1us test, zda jsou njak data od PC
	goto	Monit2		; 1us jsou data - peruen

; ----- bit 4 (9 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	btfsc	RecW,4		; 1us m bt bit 4?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	btfss	PORTB,0		; 1us
	bsf	RecW,5		; 1us
	btfss	PORTB,0		; 1us
	bsf	RecW,5		; 1us
	nop			; 1us

; ----- bit 5 (9 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	btfsc	RecW,5		; 1us m bt bit 5?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	btfss	PORTB,0		; 1us ()
	bsf	RecW,6		; 1us ()
	btfss	PORTB,0		; 1us
	bsf	RecW,6		; 1us
	nop			; 1us

; ----- bit 6 (8 us)

	andlw	~b'100'		; 1us vynulovn bitu 2
	btfsc	RecW,6		; 1us m bt bit 6?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

; ----- bit 7 (9 us)

	andlw	~b'100'		; 1us vynulovn bitu 2

	btfss	PORTB,0		; 1us
	bsf	RecW,7		; 1us
	btfss	PORTB,0		; 1us
	bsf	RecW,7		; 1us

	btfsc	RecW,7		; 1us m bt bit 7?
	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	clrf	RecW		; 1us
	nop			; 1us
	nop			; 1us
	btfss	PORTB,1		; 1us test, zda jsou njak data od PC
	goto	Monit2		; 1us jsou data - peruen

; ----- STOP (10 us)

	btfss	PORTB,0		; 1us
	bsf	RecW,0		; 1us

	iorlw	b'100'		; 1us nastaven bitu 2
	movwf	PORTB		; 1us odesln hodnoty bitu

	btfss	PORTB,0		; 1us ()
	bsf	RecW,0		; 1us ()
	nop			; 1us
	nop			; 1us

	btfsc	PORTB,1		; 1us test, zda jsou njak data od PC
	goto	Monit1		; 2us

; ----- peruen monitorovn

Monit2	bsf	PORTB,2		; nastaven STOP bitu
	bsf	RCSTA,7		; povolen USART portu
	goto	Receiv		; pokraovn v pjmu

;--------------------------------------------------------------------------
;	vysln IR povelu
;--------------------------------------------------------------------------

Send	bsf	PORTB,INDBIT	; zapnut LED pro indikaci

; ----- pprava pro tyfzovou modulaci

	clrf	ParTPM		; nulovn parametr tyfzov modulace
	movlw	6		; tyfzov modulace
	subwf	Modul,W		; test modulace
	btfsc	STATUS,Z	; je to tyfzov modulace?
	bsf	ParTPM,7	; nastaven pznaku tyfzov modulace

; ----- vyslan hlaviky kdu

	movf	Head1,W		; dlka hlaviky kdu (0=nen)
	btfsc	STATUS,Z	; je njak hlavika kdu?
	goto	Send12		; nen hlavika kdu

	call	Signal		; vysln hlaviky kdu

; ----- pro tyfzovou modulaci jet 1/2 impulsu

	btfsc	ParTPM,7	; je tyfzov modulace?
	call	Signal5		; vysln polovinho signlu

; ----- vodn impuls

Send12	movf	Head2,W
	btfss	STATUS,Z
	call	Prodlev

; ----- pro tyfzovou modulaci vusln startovacho impulsu

	movlw	2		; dlka 2
	btfsc	ParTPM,7	; je tyfzov modulace?
	call	Signal		; vysln signlu 2
	btfsc	ParTPM,7	; je tyfzov modulace?
	call	Signal5		; vysln polovinho signlu

; ----- pprava ukazatele dat kdu

	movlw	Codes0		; adresa zatku dat
	movwf	DataI		; ukazatel dat kdu	
	movf	Bites,W		; poet bit kdu
	movwf	DataB		; ta bit kdu

; ----- test, zda je nekdovan formt

	movf	Modul,W		; modulace
	btfss	STATUS,Z	; je bez modulace?
	goto	Start3		; je njak modulace

; ----- pprava bajtu k odesln

Send21	movf	DataI,W		; ukazatel dat
	movwf	FSR		; nastaven ukazatele dat
	incf	DataI,F		; zven ukazatele dat
	movf	INDF,W		; naten bajtu k odesln
	movwf	PushWB		; schova bajtu

; ----- odesln impulsu "1" 

	movlw	b'11'		; maska 2 bit
	andwf	PushWB,W	; bity 0 a 1
	addlw	1		; hodnota 1 a 4
	call	Signal		; vysln impulsu "1"

; ----- odesln impulsu "0"

	rrf	PushWB,F
	rrf	PushWB,F	; pprava dalch 2 bit
	movlw	b'11'		; maska 2 bit
	andwf	PushWB,W	; bity 0 a 1
	addlw	1		; hodnota 1 a 4
	call	Prodlev		; odesln impulsu "0"

; ----- ta bit k odesln

	decf	DataB,F		; ta bit k odesln	
	btfsc	STATUS,Z	; je ta bit = 0 ?
	goto	Start42		; byl to posledn bit, konec

; ----- odesln impulsu "1" 

	rrf	PushWB,F
	rrf	PushWB,F	; pprava dalch 2 bit
	movlw	b'11'		; maska 2 bit
	andwf	PushWB,W	; bity 0 a 1
	addlw	1		; hodnota 1 a 4
	call	Signal		; vysln impulsu "1"

; ----- odesln impulsu "0"

	rrf	PushWB,F
	rrf	PushWB,F	; pprava dalch 2 bit
	movlw	b'11'		; maska 2 bit
	andwf	PushWB,W	; bity 0 a 1
	addlw	1		; hodnota 1 a 4
	call	Prodlev		; odesln impulsu "0"

; ----- ta bit k odesln

	decfsz	DataB,F		; ta bit
	goto	Send21		; odesln dalho bitu
	goto	Start42		; pokraovn odeslnm konce dat

; ----- pprava potu bit pro jeden bajt

Start3	movlw	8		; poet bit na 1 bajt
	subwf	DataB,W		; test zbylch bit
	movlw	8		; omezen na 8 bit
	btfss	STATUS,C	; je >= 8 bit
	movf	DataB,W		; zbyl poet bit

	subwf	DataB,F		; odeten bit k odesln
	movwf	DataB0		; poet bit pro 1 bajt

; ----- pprava bajtu k odesln

	movf	DataI,W		; ukazatel dat
	movwf	FSR		; nastaven ukazatele dat
	incf	DataI,F		; zven ukazatele dat
	movf	INDF,W		; naten bajtu k odesln

; ----- odesln bajtu dat

Start4	call	OutBit
	decfsz	DataB0,F
	goto	Start4

; ----- odesln dalho bajtu dat

	movf	DataB,W
	btfss	STATUS,Z
	goto	Start3

; ----- odesln pedkonce

Start42	movf	Tail1,W
	btfss	STATUS,Z	
	call	Signal

	movf	Tail2,W
	btfss	STATUS,Z
	call	Prodlev

; ----- zakonen pro tyfzovou modulaci

	btfss	ParTPM,7	; je tyfzov modulace?
	goto	Start46		; nen tyfzov modulace

	movf	Tail2,W		; je pedkonec?
	btfss	STATUS,Z
	goto	Start46		; je pedkonec

	movf	Tail3,W		; je konec?
	btfsc	STATUS,Z
	goto	Start48		; nen konec

	decf	Tail3,W		; konec - 1 (byl ji odesln)
	goto	Start47		; odesln konce

; ----- odesln konce

Start46	movf	Tail3,W
Start47	btfss	STATUS,Z	
	call	Signal

; ----- prodleva mezi kdy

Start48	bcf	PORTB,IROBIT	; vypnut vstupu infra

	movf	IntDel,W
	movwf	Citac3

Start5	movlw	76
	movwf	Citac1		; 2 us

Start52	decfsz	Citac1,F	; as 75*3 + 2 = 227 us
	goto	Start52

Start53	decfsz	Citac1,F	; as 255*3 + 2 = 767 us
	goto	Start53

	nop			; jen tak pro doplnn na 1000 us

	decfsz	Citac3,F
	goto	Start5		; 3 us

; ----- ta kd

	decfsz	Repeat,F	; poet	opakovn
	goto	Send		; odesln dalho kdu

; ----- potvrzen operace

	movlw	0x4f		; znak potvrzen pjmu
	call	TXByte		; odesln hlen potvrzen pjmu

	bcf	PORTB,INDBIT	; vypnut LED pro indikaci

	goto	Receiv		; pjem dalho bajtu

;--------------------------------------------------------------------------
;	pjem bajtu z USART do W
;--------------------------------------------------------------------------

; ----- nulovn pznaku peteen pijmae

RXByte	btfsc	RCSTA,1		; bylo peteen pijmae OERR?
	bcf	RCSTA,4		; zkaz pjmu pro vynulovn chyby OERR
	bsf	RCSTA,4		; povolen pjmu
	bsf	RCSTA,7		; povolen USART portu

; ----- ekn na pjem bajtu od PC

RXByte2	btfss	PIR1,5		; jsou pijat data (RCIF)?
	goto	RXByte2		; ekn na pjem bajtu
	movf	RCREG,W		; pjem bajtu
	return

;; ----- pprava registr
;
;RXByte	movlw	8		; poet bit k pjmu
;	movwf	Citac2		; pprava tae bit k pjmu
;
;; ----- ekn na START bit
;
;RXByte2	btfsc	PORTB,1		; (1) je START bit?
;	goto	RXByte2		; (2,1) ekn na START bit
;
;; ----- doplnk na prodlevu 77 us (= (10-1)*3 + (14-1)*3 + 11)
;
;	movlw	10		; (1) doba
;	movwf	Citac1		; (1) pprava tae
;RXByte3	decfsz	Citac1,F	; (1) dekrementace tae
;	goto	RXByte3		; (2,1) dal cyklus
;
; ----- prodleva 52 us (= (14-1)*3 + 13)
;
;RXByte4	movlw	14		; (1) doba
;	movwf	Citac1		; (1) pprava tae
;RXByte5	decfsz	Citac1,F	; (1) dekrementace tae
;	goto	RXByte5		; (2,1) dal cyklus
;
;; ----- naten hodnoty bitu
;
;	bcf	STATUS,C	; (1) nulovn bitu
;	btfsc	PORTB,1		; (1) naten hodnoty bitu
;	bsf	STATUS,C	; (1) nastaven bitu
;	rrf	RecW,F		; (1) rotace bitu do stadae
;
;; ----- dal bit
;
;	goto	$+1		; (2) doplnk asovn
;	decfsz	Citac2,F	; (1) ta bit k pjmu
;	goto	RXByte4		; (2,1) pjem dalho bitu
;
;; ----- naten bajt
;
;	movf	RecW,W
;
;; ----- ekn na STOP bit (sta posledn datov bit "1")
;
;RXByte6	btfss	PORTB,1		; je STOP bit?
;	goto	RXByte6		; ekn na STOP bit
;	return

;--------------------------------------------------------------------------
;	odesln bajtu z W na USART (ni obsah W)
;--------------------------------------------------------------------------

; ----- povolen vysln

TXByte	bsf	STATUS,RP0	; banka 1
	bsf	TXSTA,5		; povolen vysln
	bcf	STATUS,RP0	; banka 0
	bsf	RCSTA,7		; povolen USART portu

; ----- ekn na uvolnn vyslacho bufferu

TXByte2	btfss	PIR1,4		; je vyslac buffer przdn?
	goto	TXByte2		; ekn na uvolnn vyslacho bufferu
	movwf	TXREG		; odesln bajtu
	return

;; ----- pprava registr, zapnut START bitu
;
;TXByte	bcf	PORTB,2		; (1) nastaven START bitu
;	movwf	RecW		; (1) uloen bajtu k odesln
;	movf	PORTB,W		; (1) naten portu B
;	movlw	10		; (1) poet bit k odesln
;	movwf	Citac2		; (1) pprava tae bit k odesln
;	nop			; (1) doplnk na 13 us
;
;; ----- prodleva (pro 19200 Baud je to 52 us = (14-1)*3 + 13)
;
;TXByte2	movlw	14		; (1) doba
;	movwf	Citac1		; (1) pprava tae
;TXByte3	decfsz	Citac1,F	; (1) dekrementace tae
;	goto	TXByte3		; (2,1) dal cyklus
;
;; ----- nastaven hodnoty bitu
;
;	andlw	~b'100'		; (1) vypnut vstupnho bitu
;	btfsc	RecW,0		; (1) test bitu 0
;	iorlw	b'100'		; (1) zapnut vstupnho bitu
;	movwf	PORTB		; (1) odesln hodnoty bitu
;
;; ----- pprava dalho bitu
;
;	bsf	STATUS,C	; (1) nastaven C (kvli STOP bitu)
;	rrf	RecW,F		; (1) rotace dalho bitu
;	decfsz	Citac2,F	; (1) ta bit k odesln
;	goto	TXByte2		; (2) odesln dalho bitu
;	return

;**************************************************************************
;
;                           Vstup signlu
;
;**************************************************************************

;--------------------------------------------------------------------------
;	Vstup signlu (doba W * T) (neuchovv W)
;--------------------------------------------------------------------------

Signal0	movlw	1

; ----- inicializace ta

Signal	movwf	Citac2		; ta 2 dlky signlu
Signal1	movf	Base,W		; bze pro T
Signal2	movwf	Citac1		; ta 1 dlky signlu

; ----- vstup signlu "1"

Signal3	bsf	PORTB,IROBIT	; zapnut vstupu infra
	movf	Carrier,W	; kd frekvence pro "1"
	call	Delay		; prodleva pro "1"
	nop			; asov korekce
	
; ----- vstup signlu "0"

	movf	Carrier,W	; kd frekvence pro "0"
	bcf	PORTB,IROBIT	; vypnut vstupu infra
	call	Delay		; prodleva pro "0"
	decfsz	Citac1,F	; dekrementace tae
	goto	Signal3		; dal puls signlu

; ----- dal perioda signlu
	
	decfsz	Citac2,F	; dekrementace tae
	goto	Signal1		; dal T signlu

	return


; ----- vysln polovinho signlu

Signal5	movlw	1
	movwf	Citac2		; ta 2 dlky signlu
	bcf	STATUS,C	; nulovn pznaku penosu
	rrf	Base,W		; bze pro T/2
	iorlw	0		; test, zda je vsledek = 0
	btfss	STATUS,Z	; je vsledek = 0?
	goto	Signal2		; vysln impulsu
	return			; pli krtk bze

;--------------------------------------------------------------------------
;	Vstup prodlevy (doba W * T) (neuchovv W)
;--------------------------------------------------------------------------

Prodl0	movlw	1

; ----- inicializace ta

Prodlev	movwf	Citac2		; ta 2 dlky prodlevy
Prodl1	movf	Base,W		; bze pro T
	movwf	Citac1		; ta 1 dlky prodlevy

; ----- vstup signlu "0"

Prodl2	bcf	PORTB,IROBIT	; vypnut vstupu infra
	movf	Carrier,W	; kd frekvence pro "1"
	call	Delay		; prodleva pro "1"
	nop			; asov korekce
	
; ----- vstup signlu "0"

	movf	Carrier,W	; kd frekvence pro "0"
	bcf	PORTB,IROBIT	; vypnut vstupu infra
	call	Delay		; prodleva pro "0"
	decfsz	Citac1,F	; dekrementace tae
	goto	Prodl2		; dal puls prodlevy

; ----- dal perioda prodlevy
	
	decfsz	Citac2,F	; dekrementace tae
	goto	Prodl1		; dal T prodlevy

	return

;--------------------------------------------------------------------------
;	Vstup datovho bitu (bit 0 v registru W, W rotuje o 1 bit vpravo)
;--------------------------------------------------------------------------

; ----- schova W a skok na obsluhu modulace

OutBit	movwf	PushWB		; schova W
	goto	ModTab


; ----- tato modulace se obsluhuje jinde!

OutNUL


; ***** modulace ky pulsu

; ----- vstup modulovanho signlu

OutPWM	movlw	1		; dlka signlu pro "0"
	btfsc	PushWB,0	; test bitu 0
	movlw	2		; dlka signlu pro "1"	
	call	Signal		; vstup signlu

; ----- vstup koncov prodlevy

	call	Prodl0		; vstup prodlevy
	goto	OutBit9


; ***** modulace ky mezery

; ----- vstup vodnho signlu

OutSWM	call	Signal0		; vstup signlu

; ----- vstup prodlevy signlu (3*signl pro "1", 1*signl pro "0")

	movlw	1		; dlka prodlevy pro "0"
	btfsc	PushWB,0	; test bitu 0
	movlw	3		; dlka prodlevy pro "1"	
	call	Prodlev		; vstup prodlevy
	goto	OutBit9


; ***** modulace pomrn ky

; ----- rozlien bitu

OutRWM	btfsc	PushWB,0	; test bitu 0
	goto	OutRWM2		; bude bit "1"

; ----- vstup bitu "0"

	call	Signal0		; vstup signlu
	movlw	3
	call	Prodlev		; vstup prodlevy
	goto	OutBit9

; ----- vstup bitu "1"

OutRWM2	movlw	3
	call	Signal		; vstup signlu
	call	Prodl0		; vstup prodlevy
	goto	OutBit9


; ***** modulace zmny hrany

; ----- rozlien bitu

OutESM	btfsc	PushWB,0	; test bitu 0
	goto	OutESM2		; bude bit "1"

; ----- vstup bitu "0"

	call	Signal0		; vstup signlu
	call	Prodl0		; vstup prodlevy
	goto	OutBit9

; ----- vstup bitu "1"

OutESM2	call	Prodl0		; vstup prodlevy
	call	Signal0		; vstup signlu
	goto	OutBit9


; ***** modulace ky bitu

; ----- rozlien bitu

OutBWM	btfsc	PushWB,0	; test bitu 0
	goto	OutBWM2		; bude bit "1"

; ----- vstup bitu "0"

	call	Signal0		; vstup signlu
	call	Prodl0		; vstup prodlevy
	goto	OutBit9

; ----- vstup bitu "1"

OutBWM2	movlw	2
	call	Signal		; vstup signlu
	movlw	2
	call	Prodlev		; vstup prodlevy
	goto	OutBit9


; ***** tyfzov modulace

; ----- zmna pznaku bitu

OutTPM	movlw	bit0		; bit k inverzi
	xorwf	ParTPM,F	; inverze bitu
	btfss	ParTPM,0	; je to druh bit?
	goto	OutBit9		; druh bit se ignoruje

; ----- rozlien vyho bitu

	btfsc	PushWB,1	; test bitu 1
	goto	OutTPM4		; bit 1 je nastaven

; ----- rozlien niho bitu

	btfsc	PushWB,0	; test bitu 0
	goto	OutTPM2		; bit 0 je nastaven

; ----- stav 0 (signl 1-1-3-1)

	call	Prodl0		; vstup prodlevy 1
	call	Signal0		; vstup signlu 1
	movlw	3
	call	Prodlev		; vstup prodlevy 3
	goto	OutTPM8

; ----- stav 1 (signl 2-1-2-1)

OutTPM2	movlw	2
	call	Prodlev		; vstup prodlevy 2
	call	Signal0		; vstup signlu 1
	movlw	2
	call	Prodlev		; vstup prodlevy 2
	goto	OutTPM8

; ----- rozlien niho bitu

OutTPM4	btfsc	PushWB,0	; test bitu 0
	goto	OutTPM6		; bit 0 je nastaven

; ----- stav 2 (signl 3-1-1-1)

	movlw	3
	call	Prodlev		; vstup prodlevy 3
	call	Signal0		; vstup signlu 1
	call	Prodl0		; vstup prodlevy 1
	goto	OutTPM8

; ----- stav 3 (signl 4-2)

OutTPM6	movlw	4
	call	Prodlev		; vstup prodlevy 4
	call	Signal0		; vstup signlu 1

; ----- vstup zvrenho impulsu 1

OutTPM8	call	Signal0		; vstup zvrenho impulsu 1
	goto	OutBit9



; ***** nvrat W

OutBit9	rrf	PushWB,W	; nvrat W s rotac vpravo
	return


